package edu.smcvt.graphics;

import edu.smcvt.util.*;
import java.awt.*;
import java.util.*;

public class AnimationWorld extends ThreadSet<AnimObject>{	
	public AnimationWorld(){ super(); }
		
	public void tick(){
		getLock("Tick"); {
			worldTick();
			AnimObject ao;
			for(Iterator<AnimObject> i = iterator(); i.hasNext();){
				ao = i.next();
				if(ao.isExpired()) i.remove();
				else ao.tick();
			}
		} releaseLock("Tick");
	}
	
	public boolean addObj(AnimObject ao){
		boolean res;
		System.out.println("Adding");
		getLock("addObj"); {
		System.out.println("Locked");
			res = add(ao);
		} releaseLock("addObj");
		System.out.println("Released");
		return res;
	}
		
	public boolean removeObj(AnimObject ao){
		boolean res;
		getLock("removeObj"); {
			res = remove(ao);
		} releaseLock("removeObj");
		return res;
	}
	
	public void clearObjs(){
		getLock("clearObjs"); {
			clear();
		} releaseLock("clearObjs");
	}
	
	public void worldTick(){}
	public void paintEnviron(Graphics g, Dimension curSize){}
	public void resetWorld(){	clearObjs(); }
		
		
	public void paintWorld(Graphics g, Dimension curSize){
		getLock("paintWorld"); {
			paintEnviron(g, curSize);
			for(AnimObject ao : this){ ao.paintSelf(g, curSize); }
		} releaseLock("paintWorld");	
	}
}